{******************************************************}
{*                     TTT.PAS 2.01                   *}
{*      Copyright (c) TurboPower Software 1993.       *}
{*                All rights reserved.                *}
{******************************************************}

{$I APDEFINE.INC}

{$IFNDEF UseUart}
  !! Error - The settings in APDEFINE.INC are not compatible with this program
{$ENDIF}

{$IFNDEF UseOOP}
  !! Error - You must use the object-oriented interface for this program
{$ENDIF}

{$S-,R-,V-,I-,B-,F+,O+,A-,X+}

program TicTacToe;
uses
  {$IFDEF UseOpro}
  OpCrt,
  OpDos,
  {$ENDIF}
  {$IFDEF UseTpro}
  TpCrt,
  TpDos,
  {$ENDIF}
  {$IFDEF Standalone}
  Crt,
  {$ENDIF}
  ApPort,
  ApMisc,
  ApAnsi,
  DoorIO,
  Game;

begin
  if (ParamCount <> 1) then begin
    WriteLn('Usage  : TTT <fully qualified path to DOOR.SYS file>');
    WriteLn;
    WriteLn('Example: TTT C:\BBS\DOOR.SYS');
    Halt(1);
  end;

  if not ExistFile(ParamStr(1)) then begin
    WriteLn('File does not exist: ', ParamStr(1));
    Halt(1);
  end;

  if not ReadDoorSys(ParamStr(1)) then begin
    if (AsyncStatus <> ecOK) and (AsyncStatus <> ecAnsiRequired) then
      WriteLn('Can''t initialize door: ', AsyncStatus);
    Halt(1);
  end;

  DoorClrScr;
  DisplayTextFile('SIGNON', True);
  DoorGetChar;
  PlayGame;
  DoorShutDown;
end.
